<template>
    <div>
        <el-card>


            <el-form :inline="true" :model="filterQuery" class="query-form" size="mini">
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.name"
                        placeholder="业务类型"
                        style="width: 400px"
                    ></el-input>
                </el-form-item>

                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.thirdSys" placeholder="请选择第三方系统" @change="thirdSysChange">
                        <el-option
                            v-for="item in thirdSys"
                            :key="item.value"
                            :label="item.thirdName"
                            :value="item.thirdId">
                            <span style="float: left">{{ item.thirdName }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.thirdId }}</span>
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="margin-left: 10px;display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="search">查询</el-button>
                        <el-button type="primary" icon="search" @click="handleAddClick"
                                   :disabled="!configParms.typeThird"
                        >新增
                        </el-button
                        >
                        <!--                        <el-button type="primary" icon="search" @click="updateDownload">更新下载</el-button>-->
                    </el-button-group>

                </el-form-item>
            </el-form>

            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index" width="55"></el-table-column>
                <el-table-column label="单据类型名称" prop="name"></el-table-column>
                <el-table-column label="单据类型代码" prop="action"></el-table-column>
                <el-table-column label="第三方系统" prop="thirdSysName"></el-table-column>
                <el-table-column label="备注" prop="remark"></el-table-column>
                <el-table-column label="操作" width="100" fixed="right">
                    <template slot-scope="scope">
                        <el-button
                            type="text"
                            size="small"
                            :disabled="!configParms.typeThird"
                            @click.native.stop="handleModifyClick(scope.row)"
                        >编辑
                        </el-button
                        >
                        <el-button
                            type="text"
                            size="small"
                            :disabled="!configParms.typeThird"
                            @click.native.stop="handleDeleteClick(scope.row)"
                        >删除
                        </el-button
                        >
                    </template>
                </el-table-column>
            </el-table>

            <el-dialog
                title="新增第三方单据类型"
                :visible.sync="addDialogVisible"
                width="70%"
                :close-on-click-modal="false"
                :close-on-press-escape="false"
                v-if="addDialogVisible"
            >
                <modifyDialog :inputQuery="inputQuery"></modifyDialog>
                <div style="text-align: center">
                    <el-button type="primary" size="small" icon="search" @click="onAddSubmit"
                               :disabled="!configParms.typeThird"
                    >提交
                    </el-button
                    >
                    <el-button type="primary" size="small" icon="search" @click="cancelDialog"
                    >取消
                    </el-button
                    >
                </div>
            </el-dialog>

            <el-dialog
                title="编辑第三方单据类型"
                :visible.sync="modifyDialogVisible"
                width="70%"
                :close-on-click-modal="false"
                :close-on-press-escape="false"
                v-if="modifyDialogVisible"
            >
                <modifyDialog :inputQuery="inputQuery"></modifyDialog>
                <div style="text-align: center">
                    <el-button type="primary" size="small" icon="search" @click="onModifySubmit"
                               :disabled="!configParms.typeThird"
                    >提交
                    </el-button
                    >
                    <el-button type="primary" size="small" icon="search" @click="cancelDialog"
                    >取消
                    </el-button
                    >
                </div>
            </el-dialog>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
    </div>
</template>
<script>
import {
    getOriginBusType,
    updateBussinessType, delBussinessType,
    insertBussinessType, downloadBussinessType
} from "../../api/basic/busOriginType";

import modifyDialog from "./BussinessTypeThirdModify";
import axios from "axios";
import {getBasicThirdSys} from "@/api/basic/basicThirdSys";
import {findConfig} from "@/api/thrsys/spsSyncStatus";

export default {
    data() {
        return {
            filterQuery: {
                thirdSys: null,
                name: "",
                page: 1,
                limit: 20,
            },
            addDialogVisible: false,
            modifyDialogVisible: false,
            list: [],
            inputQuery: {
                action: "",
                name: "",
                enable: "",
                remark: "",
                thirdSys: null,
                thirdSysName: null,

            },
            enableMap: {
                true: "是",
                false: "否",
            },
            thirdSys: [],
            total: 0,
            multipleSelection: [],
            uploadFileUrl: null,
            loading: false,
            configParms: {},
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                thirdSys: "thirdId",
                name: null,
                enable: null,
                page: 1,
                limit: 20,
            };
            this.getList();
        },
        cancelDialog() {
            this.modifyDialogVisible = false;
            this.addDialogVisible = false;
        },
        search() {
            this.filterQuery.page = 1;
            this.getList();
        },
        getList() {
            this.loading = true;
            getOriginBusType(this.filterQuery)
                .then((response) => {
                    this.loading = false;
                    this.list = response.data.list || [];
                    if (this.list.length > 0) {
                        this.list.forEach(item => {
                            this.thirdSys.forEach(third => {
                                if (item.thirdSys === third.thirdId) {
                                    item.thirdSysName = third.thirdName;
                                }
                            })
                        })
                    }
                    this.total = response.data.total || 0;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    this.filterQuery.thirdSys = this.thirdSys[0].thirdId;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        updateDownload() {
            let query = {
                thirdSys: this.filterQuery.thirdSys,
            }
            downloadBussinessType(query)
                .then((response) => {
                    this.loading = false;
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                });
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },

        onAddSubmit() {

            if (this.$isBlank(this.inputQuery.name)) {
                this.$message.error("单据类型名称不能为空！");
                return;
            }
            if (this.$isBlank(this.inputQuery.action)) {
                this.$message.error("单据类型代码不能为空！");
                return;
            }
            if (this.$isBlank(this.inputQuery.thirdSys)) {
                this.$message.error("所属系统不不能为空！");
                return;
            }
            let numRegExp = '^[0-9]*$';
            let numReg = new RegExp(numRegExp);
            if (numReg.test(this.inputQuery.name)) {
                this.$message.error("单据类型名称不得为纯数字类型！");
                return;
            }

            insertBussinessType(this.inputQuery)
                .then((response) => {

                    if (response.code == 20000) {
                        this.loading = false;
                        this.cancelDialog();
                        this.getList();

                    } else {
                        this.$message.error(response.message);
                    }

                })
                .catch(() => {
                    this.loading = false;
                    this.cancelDialog();
                });
        },

        onModifySubmit() {
            if (this.$isBlank(this.inputQuery.name)) {
                this.$message.error("单据类型名称不能为空！");
                return;
            }
            if (this.$isBlank(this.inputQuery.action)) {
                this.$message.error("单据类型代码不能为空！");
                return;
            }
            if (this.$isBlank(this.inputQuery.thirdSys)) {
                this.$message.error("所属系统不不能为空！");
                return;
            }
            updateBussinessType(this.inputQuery)
                .then((response) => {
                    this.loading = false;
                    this.cancelDialog();
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.cancelDialog();
                });
        },

        handleModifyClick(row) {

            this.inputQuery = {
                id: row.id,
                remark: row.remark,
                action: row.action,
                name: row.name,
                enable: row.enable,
                thirdSys: row.thirdSys,
                thirdSysName: row.thirdSysName
            };
            this.modifyDialogVisible = true;
        },


        handleDeleteClick(row) {
            this.deleteDialog(row.id)
        },

        handleAddClick() {
            this.inputQuery = {
                action: "",
                name: "",
                enable: "",
                remark: "",
                thirdSys: null,
                thirdSysName: null
            };
            this.addDialogVisible = true;
        },

        deleteDialog(rowId) {
            this.$confirm("此操作将永久删除该单据类型信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let query = {
                        id: rowId,
                    }
                    delBussinessType(query)
                        .then((response) => {
                            this.getList();
                        })
                        .catch(() => {
                        });


                })
                .catch(() => {
                });
        },

        thirdSysChange() {
            this.getList();
        },

        init() {
            axios.get("./config.json").then(res => {
                // 基础地址
                let response = res.data.BASE_URL;
                this.uploadFileUrl = response + "udiwms/busstiness/file/upload";
            });
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                // console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success(response.data);
                this.getList();
            }
        },
        getSyncConfig() {
            findConfig()
                .then((response) => {
                    if (response.code == 20000) {
                        this.configParms = response.data;
                    }
                })
                .catch(() => {
                });
        },
    },
    components: {
        modifyDialog,
    },
    mounted() {
    },
    created() {
        this.init();
        this.getSyncConfig();
        this.getBasicThirdSys();
        this.getList();

    },
};
</script>
